<template>
    <v-container>
        <v-row>
            <v-col>
                <!-- TODO - title to input -->
                <component 
                    :is="transform.title" 
                    @click="onTransform('title')"
                    ref="title"
                    data-focus="title"
                    v-model="form.title"
                    v-on:keyup.enter="submit('title')"
                    >
                    {{  form.title }}
                </component>
                <div>In list #{{  todo.list }}</div>
            </v-col>
        </v-row>
        <v-row>
            <v-col>
                <h4>Description</h4>
                <v-form @submit.prevent="submit('description')">
                    <component
                        :is="transform.description"
                        ref="description"
                        data-focus="description"
                        v-model="form.description"
                        @click="onTransform('description')"
                        class="todo-description"
                    >
                        {{  form.description }}
                    </component>
                    <div v-show="transform.description == allTransforms.description[1]">
                        <v-btn type="submit">Save</v-btn>
                        <v-btn @click="onTransform('description', true)">Cancel</v-btn>
                    </div>
                </v-form>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
import { VTextarea, VTextField } from 'vuetify/lib'

const transforms = {
    title: ['h2', 'v-text-field'],
    description: ['div', 'v-textarea'],
}

    export default {
        name: "EditTodoFull",
        components:{
            VTextarea,
            VTextField,
        },
        props: {
            todo: {
                required: true,
                type: Object,
            },
            onChange:{
                required: true,
            }
        },
        data:()=>({
            form:{},
            transform:{
                title: transforms.title[0],
                description: transforms.description[0],
            },
            activeElement: null,
        }),
        computed:{
            allTransforms(){
                return transforms;
            }
        },
        created() {
            document.addEventListener('focusin', this.focusChanged)
            this.form = {...this.todo};
        },
        beforeDestroy() {
            document.removeEventListener('focusin', this.focusChanged)
        },
        methods:{
            onTransform(key, forced=false){
                if(this.activeElement == key && !forced){
                    return;
                }
                this.transform[key] = this.transform[key] == transforms[key][0] ? transforms[key][1] : transforms[key][0];
                this.$nextTick(()=>{
                    if(this.transform[key] == transforms[key][1]){
                        this.$refs[key].focus();
                    }
                })

            },
            focusChanged (event) {
                const el = event.target
                this.activeElement = el ? el.dataset.focus : null;
                
            },
            submit(key){
                this.onTransform(key, true);
                if(this.todo[key] != this.form[key]){
                    this.onChange(this.todo.id, {
                        [key]: this.form[key]
                    })
                }
            }
        },
       
    }
</script>

<style lang="scss" scoped>
    .todo-description{
        min-height: 50px;
        outline: 1px dotted grey;
    }
</style>